package com.chinaitop.depot;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.chinaitop.depot.agent.feign.AgileHouseFeignClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;

/**
 * @author qingsong.han
 * @description:
 * @create 2020-07-20 15:16
 */
@Component
public class HystrixClientFallback implements AgileHouseFeignClient {
    private final static Logger logger = LoggerFactory.getLogger(HystrixClientFallback.class);

    @Override
    public JSONArray queryQcCrkRecordData(String datas) {
        logger.info("queryQcCrkRecordData: " + datas);
        return null;
    }

    @Override
    public JSONArray queryHcCrkRecordData(String datas) {
        logger.info("queryHcCrkRecordData: " + datas);
        return null;
    }

    @Override
    public JSONArray queryKcswData(String datas) {
        logger.info("queryKcswData: " + datas);
        return null;
    }

    @Override
    public JSONArray queryFcbgzData(String datas) {
        logger.info("queryFcbgzData: " + datas);
        return null;
    }

}
