package com.chinaitop.depot.agent.basic.service.impl;

import com.chinaitop.depot.agent.basic.mapper.BusinessAgentDepotMapper;
import com.chinaitop.depot.agent.basic.mapper.BusinessAgentMapper;
import com.chinaitop.depot.agent.basic.mapper.BusinessAgentStorehouseMapper;
import com.chinaitop.depot.agent.basic.model.*;
import com.chinaitop.depot.agent.basic.service.agentDepotService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
public class AgentDepotServiceImpl implements agentDepotService {

    @Resource
    private BusinessAgentDepotMapper BusinessAgentDepotMapper;

    @Resource
    private BusinessAgentMapper BusinessAgentMapper;

    @Resource
    private BusinessAgentStorehouseMapper businessAgentStorehouseMapper;

    /**
     * 查询仓储处作业记录
     * * @param map
     * @return
     */
    @Override
    public List<BusinessAgentDepot> getAgentDepotList(BusinessAgentDepotExample map) {
        return BusinessAgentDepotMapper.selectByExample(map);
    }

    @Override
    public List<BusinessAgentDepot> getAgentList(Map<String, Object> map) {
        return BusinessAgentDepotMapper.getByExample(map);
    }

    @Override
    public List<Map<String,Object>> getDepotLaoList(Map<String, Object> map) {
        return BusinessAgentDepotMapper.getDepotLaoList(map);
    }

    @Override
    public List<Map<String, Object>> getHouseDepotList(Map<String, Object> map) {
        return BusinessAgentDepotMapper.getHouseDepotList(map);
    }

    @Override
    public List<Map<String, Object>> getTankDepotList(Map<String, Object> map) {
        return BusinessAgentDepotMapper.getTankDepotList(map);
    }

    @Override
    public void add(BusinessAgentDepot agent) {
        BusinessAgentDepotMapper.insert(agent);
    }

    @Override
    public void update(BusinessAgentDepot camera) {
        BusinessAgentDepotMapper.updateByPrimaryKey(camera);
    }

    @Override
    public void updateByPrimaryKeySelective(BusinessAgentDepot camera) {
        BusinessAgentDepotMapper.updateByPrimaryKeySelective(camera);
    }

    @Override
    public Integer getIdHouse(Integer depotId) {
        return BusinessAgentDepotMapper.getIdHouse(depotId);
    }

    @Override
    public void updateDeleteById(Integer depotId,Integer delFlag) {
        BusinessAgentDepot businessAgentDepot = new BusinessAgentDepot();
        businessAgentDepot.setId(depotId);
        businessAgentDepot.setDelFlag(delFlag);
        BusinessAgentDepotMapper.updateByPrimaryKeySelective(businessAgentDepot);
    }

    @Override
    public List<Map<String, Object>> getDepot(Map<String, Object> map) {
        return BusinessAgentDepotMapper.getDepot(map);
    }

    @Override
    public BusinessAgentDepot findById(Integer id) {
        return BusinessAgentDepotMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<BusinessAgentDepot> selectIdNum(BusinessAgentDepotExample example) {
        return BusinessAgentDepotMapper.selectByExample(example);
    }

    @Override
    public String importData(List<List<String>> list, Integer orgId) {
        Date date = new Date();
        BusinessAgentDepot agent = null;

        String msg = "";
        int len = 0;

        for (int i = 0; i < list.size(); i++) {
            List<String> revList = list.get(i);

            for (int j = 0; j < revList.size(); j++) {
                switch(j) {
                    case 0:
                        //库点名称
                        agent = new BusinessAgentDepot();
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 30) {
                                msg = "第 "+(i+1)+" 行第 1 列的值的长度不能超过30！";
                                return msg;
                            }
                            agent.setAgentDepotName(revList.get(j));
                        }
                        agent.setCreateTime(date);//修改时间
                        agent.setOrgId(orgId);
                        break;
                    case 1:
                        //代储点名称
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {

                            BusinessAgentExample example = new BusinessAgentExample();
                            BusinessAgentExample.Criteria criteria = example.createCriteria();
                            criteria.andOrgIdEqualTo(orgId);
                            criteria.andAgentNameEqualTo(revList.get(j));
                            List<BusinessAgent> agentList = BusinessAgentMapper.selectByExample(example);
                            if(agentList.size() == 0){
                                msg = "第 "+(i+1)+" 行第 2 列的值的代储点相关信息没有找到，请确定是否有！";
                                return msg;
                            }

                            agent.setAgentId(agentList.get(0).getId().toString());
                        }
                        break;
                    case 2:
                        //库点类别
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 30) {
                                msg = "第 "+(i+1)+" 行第 3 列的值的长度不能超过30！";
                                return msg;
                            }
                        }
                        agent.setDepotType(revList.get(j));
                        break;
                    case 3:
                        //设计仓容
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 30) {
                                msg = "第 "+(i+1)+" 行第 4 列的值的长度不能超过30！";
                                return msg;
                            }
                        }
                        agent.setDesignStorage(revList.get(j));
                        break;
                    case 4:
                        //地址
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setAddress(revList.get(j));
                        break;
                    case 5:
                        //电话
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 6 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setPhone(revList.get(j));
                        break;
                    case 6:
                        //经度
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 7 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setLongitude(revList.get(j));
                        break;
                    case 7:
                        //纬度
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 8 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setLatitude(revList.get(j));
                        break;
                    case 8:
                        //所属行政区划
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 9 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setAdministrativeArea(revList.get(j));
                        break;
                    default :
                        break;
                }
            }
            agent.setDelFlag(1);
            agent.setDepotId(0);
            BusinessAgentDepotMapper.insert(agent);
        }
        return msg;
    }

    @Override
    public List<Integer> getAgentHouseId(Integer orgId) {
        return businessAgentStorehouseMapper.getAgentHouseId(orgId);
    }
}
