package com.chinaitop.depot.agent.basic.service.impl;

import com.chinaitop.depot.agent.basic.mapper.BusinessAgentMapper;
import com.chinaitop.depot.agent.basic.model.BusinessAgent;
import com.chinaitop.depot.agent.basic.model.BusinessAgentExample;
import com.chinaitop.depot.agent.basic.service.agentService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
public class AgentServiceImpl implements agentService {

    @Resource
    private BusinessAgentMapper BusinessAgentMapper;

    /**
     * 查询仓储处作业记录
     * * @param map
     * @return
     */
    @Override
    public List<BusinessAgent> getAgentList(BusinessAgentExample map) {
        return BusinessAgentMapper.selectByExample(map);
    }

    @Override
    public void add(BusinessAgent agent) {
        BusinessAgentMapper.insert(agent);
    }

    @Override
    public void update(BusinessAgent camera) {
        BusinessAgentMapper.updateByPrimaryKey(camera);
    }

    @Override
    public void updateDeleteById(Integer agentId) {
        BusinessAgent businessAgent = new BusinessAgent();
        businessAgent.setId(agentId);
        businessAgent.setDelFlag(2);
        BusinessAgentMapper.updateByPrimaryKeySelective(businessAgent);
    }

    @Override
    public BusinessAgent findById(Integer id) {
        return BusinessAgentMapper.selectByPrimaryKey(id);
    }

    @Override
    public Map<String,Object> getNameId(Map<String,Object> map) {
        return BusinessAgentMapper.getNameId(map);
    }

    @Override
    public String importData(List<List<String>> list, Integer orgId) {
        Date date = new Date();
        BusinessAgent agent = null;

        String msg = "";
        int len = 0;

        for (int i = 0; i < list.size(); i++) {
            List<String> revList = list.get(i);

            for (int j = 0; j < revList.size(); j++) {
                switch(j) {
                    case 0:
                        //代储点名称
                        agent = new BusinessAgent();
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 30) {
                                msg = "第 "+(i+1)+" 行第 1 列的值的长度不能超过30！";
                                return msg;
                            }
                            agent.setAgentName(revList.get(j));
                        }
                        agent.setCreateTime(date);//修改时间
                        agent.setOrgId(orgId);
                        break;
                    case 1:
                        //法定代表人
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 30) {
                                msg = "第 "+(i+1)+" 行第 2 列的值的长度不能超过30！";
                                return msg;
                            }
                        }
                        agent.setLegalPerson(revList.get(j));
                        break;
                    case 2:
                        //统一社会信用代码
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 30) {
                                msg = "第 "+(i+1)+" 行第 3 列的值的长度不能超过30！";
                                return msg;
                            }
                        }
                        agent.setCreditCode(revList.get(j));
                        break;
                    case 3:
                        //代储点性质
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 4 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setAgentNature(revList.get(j));
                        break;
                    case 4:
                        //代储点类型
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setAgentType(revList.get(j));
                        break;
                    case 5:
                        //仓容
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setCapacity(revList.get(j));
                        break;
                    case 6:
                        //人员
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setPerson(revList.get(j));
                        break;
                    case 7:
                        //信用
                        len = revList.get(j).length();
                        if (len > 20) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过20！";
                            return msg;
                        }
                        agent.setCredit(revList.get(j));
                        break;
                    case 8:
                        //经度
                        len = revList.get(j).length();
                        if (len > 100) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过100！";
                            return msg;
                        }
                        agent.setLongitude(revList.get(j));
                        break;
                    case 9:
                        //维度
                        len = revList.get(j).length();
                        if (len > 100) {
                            msg = "第 "+(i+1)+" 行第 5 列的值的长度不能超过100！";
                            return msg;
                        }
                        agent.setLatitude(revList.get(j));
                        break;
                    case 10:
                        //所属行政区划
                        if (revList.get(j) != null && !"".equals(revList.get(j))) {
                            len = revList.get(j).length();
                            if (len > 50) {
                                msg = "第 "+(i+1)+" 行第 11 列的值的长度不能超过50！";
                                return msg;
                            }
                        }
                        agent.setAdministrativeArea(revList.get(j));
                        break;
                    default :
                        break;
                }

            }
            agent.setDelFlag(1);
            BusinessAgentMapper.insert(agent);
        }
        return msg;
    }
}
