package com.chinaitop.depot.agent.basic.service.impl;

import com.chinaitop.depot.agent.basic.mapper.BusinessAgentWarehouseMapper;
import com.chinaitop.depot.agent.basic.model.BusinessAgentStorehouse;
import com.chinaitop.depot.agent.basic.model.BusinessAgentWarehouse;
import com.chinaitop.depot.agent.basic.model.BusinessAgentWarehouseExample;
import com.chinaitop.depot.agent.basic.service.agentStoreWareService;

import com.chinaitop.utils.ParameterUtil;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;


@Service
public class AgentStoreWareServiceImpl implements agentStoreWareService {

    @Resource
    private BusinessAgentWarehouseMapper businessAgentWarehouseMapper;

    //
	@Override
	public List<Map<String, Object>> getAgentStoreWare(Map<String, Object> map) {
		// TODO Auto-generated method stub
		return businessAgentWarehouseMapper.getAgentStoreWare(map);
	}

	@Override
	public void addWareHouse(BusinessAgentWarehouse warehouse) {
		businessAgentWarehouseMapper.insert(warehouse);
	}

	@Override
	public List<Map<String, Object>> getWareList(Map<String, Object> map) {
		return businessAgentWarehouseMapper.getWareList(map);
	}

	@Override
	public List<Map<String, Object>> getWare(Map<String, Object> map) {
		return businessAgentWarehouseMapper.getWare(map);
	}

	@Override
	public void removeAgentWare(Integer wareId,Integer delFlag) {
		BusinessAgentWarehouse businessAgentWarehouse = new BusinessAgentWarehouse();
		businessAgentWarehouse.setId(wareId);
		businessAgentWarehouse.setDelFlag(delFlag);
		businessAgentWarehouseMapper.updateByPrimaryKeySelective(businessAgentWarehouse);
	}

	@Override
	public List<BusinessAgentWarehouse> getWareDataList(BusinessAgentWarehouseExample example) {
		return businessAgentWarehouseMapper.selectByExample(example);
	}

	@Override
	public List<Integer> getAgentwareHouseId(Integer orgId) {
		// TODO Auto-generated method stub
		return businessAgentWarehouseMapper.getAgentwareHouseId(orgId);
	}

	@Override
	public Map<String, Object> getWarehouse(Integer unitId, Integer storehouseId) {
		Map<String, Object> mapData = new HashMap<String, Object>();

		Map<String,Object> map = new HashMap<>();
		if(ParameterUtil.isnotnull(unitId)){
			map.put("orgId",unitId);
		}
		if(ParameterUtil.isnotnull(storehouseId)){
			map.put("storehouseId",storehouseId);
		}

		List<Map<String, Object>> list = businessAgentWarehouseMapper.getWarehouse(map); //获取库点下的某个仓房中的的货位
		//处理驼峰命名大写问题
		List<Map<String, Object>> listDatas = ParameterUtil.slashCapitals(list);
		mapData.put("wareList", listDatas); //货位下拉列表集合

		return mapData;
	}
}
