package com.chinaitop.depot.agent.bgz.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.agent.bgz.model.BusinessAgentFcbgz;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentFcbgzExample;

public interface BusinessAgentFcbgzService {

	/**
	 * 按条件查询数据
	 * 
	 * @param example 条件
	 * @return
	 */
	List<BusinessAgentFcbgz> findByConditions(BusinessAgentFcbgzExample example);

	/**
	 * 更新数据
	 * 
	 * @param fcbgz 数据对象
	 */
	void update(BusinessAgentFcbgz fcbgz);

	/**
	 * 插入数据
	 * 
	 * @param fcbgz 数据对象
	 */
	void insert(BusinessAgentFcbgz fcbgz);

	/**
	 * 删除数据
	 * 
	 * @param id 数据ID
	 */
	void remove(Integer id);

	/**
     * 查询保管总账列表分组信息
     * 
     * @param map 参数
     * @return
     */
    List<Map<String, Object>> selectBgzzGroupByList(Map<String, Object> map);

	/**
	 * 查询保管总账列表其它数据
	 * 
	 * @param map 条件
	 * @return
	 */
	Map<String, Object> selectBgzzList(Map<String, Object> map);

	/**
	 * 按条件将保管明细账数据修改为已记账
	 * 
	 * @param fcbgz 条件
	 */
	void updateSfjz(BusinessAgentFcbgz fcbgz);
}
