package com.chinaitop.depot.agent.bgz.service.impl;

import java.util.Date;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.agent.bgz.mapper.BusinessAgentBgmxzMapper;
import com.chinaitop.depot.agent.bgz.mapper.BusinessAgentFcbgzMapper;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentBgmxz;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentBgmxzExample;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentBgmxzExample.Criteria;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentFcbgz;
import com.chinaitop.depot.agent.bgz.model.BusinessAgentFcbgzExample;
import com.chinaitop.depot.agent.bgz.service.BusinessAgentFcbgzService;
import com.chinaitop.utils.ParameterUtil;

@Service
public class BusinessAgentFcbgzServiceImpl implements BusinessAgentFcbgzService {

	@Resource
	private BusinessAgentFcbgzMapper fcbgzMapper;

	@Resource
	private BusinessAgentBgmxzMapper bgmxzMapper;

	@Override
	public List<BusinessAgentFcbgz> findByConditions(BusinessAgentFcbgzExample example) {
		return fcbgzMapper.selectByExample(example);
	}

	@Override
	public void update(BusinessAgentFcbgz fcbgz) {
		fcbgzMapper.updateByPrimaryKey(fcbgz);
	}

	@Override
	public void insert(BusinessAgentFcbgz fcbgz) {
		fcbgzMapper.insert(fcbgz);
	}

	@Override
	public void remove(Integer id) {
		fcbgzMapper.deleteByPrimaryKey(id);
	}

	@Override
	public List<Map<String, Object>> selectBgzzGroupByList(Map<String, Object> map) {
		List<Map<String, Object>> list = fcbgzMapper.selectBgzzGroupByList(map);
		return list;
	}

	@Override
	public Map<String, Object> selectBgzzList(Map<String, Object> map) {
		Map<String, Object> list = fcbgzMapper.selectBgzzList(map);
		return list;
	}

	@Override
	public void updateSfjz(BusinessAgentFcbgz fcbgz) {
		/* 设置要修改的数据 */
		BusinessAgentBgmxz bgmxz = new BusinessAgentBgmxz();
		bgmxz.setIsJz(1);

		/* 设置修改条件 */
		BusinessAgentBgmxzExample example = new BusinessAgentBgmxzExample();
		Criteria criteria = example.createCriteria();
		criteria.andAgentIdEqualTo(fcbgz.getAgentId());//代储点
		criteria.andSzlkOrgIdEqualTo(fcbgz.getDckId());//代储粮库
		criteria.andHouseIdEqualTo(fcbgz.getHouseId());//仓房
		criteria.andWareIdEqualTo(fcbgz.getWareId());//货位
		criteria.andLspzEqualTo(fcbgz.getLspz());//粮食品种
		criteria.andLsxzEqualTo(fcbgz.getLsxz());//粮食性质
		Date startTime = ParameterUtil.string2datetime(fcbgz.getFssj()+" 00:00:00");
		Date endTime = ParameterUtil.string2datetime(fcbgz.getFssj()+" 23:59:59");
		criteria.andFssjBetween(startTime, endTime);
		
		bgmxzMapper.updateByExampleSelective(bgmxz, example);
	}

}
